import { AfterViewInit, EventEmitter, OnChanges, OnInit, SimpleChange } from "@angular/core";
import { Router } from "@angular/router";
import { INSNavigationMenu, INSNavigationSetting } from "./interfaces";
import { NSBaseComponent } from "../ns-base";
import * as i0 from "@angular/core";
declare var NSNavigation: any;
export interface INSNavigationAngularSettings extends INSNavigationSetting {
    setting?: INSNavigationSetting;
    containerStyle?: any;
    [propName: string]: any;
}
export declare class NSNavigationAngular extends NSBaseComponent<typeof NSNavigation> implements OnChanges, OnInit, AfterViewInit {
    private router;
    set setting(value: INSNavigationAngularSettings);
    get setting(): INSNavigationAngularSettings | null | undefined;
    set dataSource(arrSource: INSNavigationMenu[]);
    get dataSource(): INSNavigationMenu[] | null | undefined;
    navigationOpenStart: EventEmitter<any>;
    navigationOpenEnd: EventEmitter<any>;
    navigationCloseStart: EventEmitter<any>;
    navigationCloseEnd: EventEmitter<any>;
    navigationMenuSelected: EventEmitter<any>;
    navigationMenuDeselected: EventEmitter<any>;
    private __dataSource;
    private __setting;
    constructor(router: Router);
    ngOnChanges(changes: {
        [propName: string]: SimpleChange;
    }): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    isNavOpen(): Boolean;
    toggleNavigation(): void;
    openNavigation(): void;
    closeNavigation(): void;
    selectMenu(itemOrElement: any): void;
    setDataSource(source: INSNavigationMenu[]): void;
    setStyle(styleProp: String, value: any): void;
    setFocus(isFocus: boolean): void;
    hasFocus(): boolean;
    setTheme(theme: string): void;
    private __manageDataSource;
    private __manageDataSourceItem;
    private __menuClickHandler;
    static ɵfac: i0.ɵɵFactoryDeclaration<NSNavigationAngular, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NSNavigationAngular, "ns-navigation-angular", never, { "setting": { "alias": "setting"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; }, { "navigationOpenStart": "navigationOpenStart"; "navigationOpenEnd": "navigationOpenEnd"; "navigationCloseStart": "navigationCloseStart"; "navigationCloseEnd": "navigationCloseEnd"; "navigationMenuSelected": "navigationMenuSelected"; "navigationMenuDeselected": "navigationMenuDeselected"; }, never, never, false, never>;
}
export {};
